# brModelo

Atualizado: brModelo 3.3 - correção de bugs e pequenas funcionalidades.

Atualizado: brModelo 3.2 - correção de bugs e pequenas funcionalidades.

brModelo 3.0

## 1. Introdução
Em 2005 foi desenvolvida uma ferramenta de código aberto e totalmente gratuita voltada para ensino de modelagem de banco de dados relacionais com base na metodologia defendida por Carlos A. Heuser no livro “Projeto de Banco de Dados”. Esta ferramenta foi concebida como trabalho de conclusão do curso de especialização em banco de dados pelas universidades UFSC (SC) e UNIVAG (MT), orientado pelo Professor Dr. Ronaldo dos Santos Mello, após se constatar a inexistência de uma ferramenta nacional que pudesse ser utilizada para essa finalidade.
Em junho de 2006 foi realizado o lançamento da versão 2.0 da ferramenta. Naquela época, acreditava-se que a modelagem de bancos de dados relacionais poderia ser substituída nos próximos dez anos por ferramentas de desenvolvimento de software orientadas a objeto que propunham a persistência do modelo de classes diretamente em um sistema de gerência de banco de dados (SGBD), sem, portanto, a necessidade de uma análise do modelo voltada exclusivamente para os dados.
Em 2015, passados dez anos de disponibilização da primeira versão da ferramenta, verifica-se ainda a existência de grande demanda por conhecimentos na área de modelagem de dados relacionais e, inclusive, a produção de novos artefatos para
abstração dos diagramas de dados, em especial, os conceitos relacionados à modelagem conceitual e lógica. O mercado não substituiu os SGBDs relacionais e novas funcionalidades têm sido implementadas. Também por isso, a brModelo continua a ser utilizada em várias universidades e centros de ensinos técnicos no pais e até mesmo no exterior.
Tudo isso motivou-nos a continuar os trabalhos de desenvolvimento e a publicar uma nova versão do brModelo, também baseada em código aberto, porém em linguagem de programação mais atual e com possibilidade de trabalhos colaborativos, cujo beta pretende ser lançada no site da ferramenta na data da próxima Escola Regional de Banco de Dados, oportunidade onde serão colhidas sugestões de melhoria pelo público para análise e possíveis aprimoramentos.

## 2. Melhorias Introduzidas na Nova Versão da brModelo
A nova versão está sendo desenvolvida em Java ™, mantém todas as funcionalidades da versão anterior e pretende implementar algumas modificações defendidas por alguns professores de modelagem de bancos de dados relacionais, publicadas em sites sobre o assunto na Internet. Assim sendo, ela oferecerá uma nova oportunidade para avanços no ensino de banco de dados.
Além disso, esta nova versão da brModelo implementa outras notações diagramáticas que podem ser uteis no processo de modelagem conceitual. Desta forma, suas bases poderão ser utilizadas para o desenvolvimento de outras notações e será usada no projeto brUML (ferramenta para o ensino de UML, ainda em fase de levantamento de requisitos).
No campo das novas funcionalidades, esta nova versão da brModelo apresenta uma nova interface com o usuário (incluindo recursos tradicionais, como copiar/colar, zoom, teclas de atalho e etc.), um novo padrão de codificação baseado no Code Conventions for the Java Programming Language, com ênfase nos padrões de projeto (principalmente Factory e Strategy), internacionalização, ajuda interativa e extensão do diagrama originalmente proposto pelo Dr. Heuser (2001), baseado no trabalho de Peter Chen (1990), com a inclusão de união de entidades.

## 3. Apresentação da Nova Versão da Ferramenta
Esta seção apresenta a nova versão da ferramenta brModelo (v3 – beta 1), que ainda em 2017 substituirá a ferramenta atualmente em uso (brModelo 2.0, disponível no site do autor: www.sis4.com).
O grande diferencial da ferramenta, quando comparada às demais, é o fato dela ter sido criada com foco no ensino e na aprendizagem da modelagem de dados relacional em nível técnico e acadêmico, ao contrário daquelas voltadas exclusivamente para auxiliar no trabalho dos profissionais de desenvolvimento de aplicações de banco de dados. A nova versão mantém o mesmo foco e aperfeiçoa os novos conceitos na área afim.
O assunto é relevante para a comunidade que atua na área de banco de dados relacionais, principalmente no tocante ao ensino e aprendizado das técnicas de modelagem. Prova disso é que foram realizados mais de 500.000 (quinhentos mil) downloads da ferramenta desde sua publicação.

## Copie, altere, publique.

## Fonte em JAVA 8.
